diff --git a/app/test-pmd/cmdline_flow.c b/app/test-pmd/cmdline_flow.c
index bdbfe79c5e..f1fb568211 100644
--- a/app/test-pmd/cmdline_flow.c
+++ b/app/test-pmd/cmdline_flow.c
@@ -515,7 +515,6 @@ enum index {
 	ACTION_METER_COLOR_MODE,
 	ACTION_METER_INIT_COLOR,
 	ACTION_METER_STATE,
-	ACTION_OF_DEC_MPLS_TTL,
 	ACTION_OF_SET_NW_TTL,
 	ACTION_OF_SET_NW_TTL_NW_TTL,
 	ACTION_OF_DEC_NW_TTL,
@@ -1835,7 +1834,6 @@ static const enum index next_action[] = {
 	ACTION_METER,
 	ACTION_METER_COLOR,
 	ACTION_METER_MARK,
-	ACTION_OF_DEC_MPLS_TTL,
 	ACTION_OF_SET_NW_TTL,
 	ACTION_OF_DEC_NW_TTL,
 	ACTION_OF_COPY_TTL_OUT,
@@ -5460,13 +5458,6 @@ static const struct token token_list[] = {
 		.args = ARGS(ARGS_ENTRY(struct rte_flow_action_meter_mark, state)),
 		.call = parse_vc_conf,
 	},
-	[ACTION_OF_DEC_MPLS_TTL] = {
-		.name = "of_dec_mpls_ttl",
-		.help = "OpenFlow's OFPAT_DEC_MPLS_TTL",
-		.priv = PRIV_ACTION(OF_DEC_MPLS_TTL, 0),
-		.next = NEXT(NEXT_ENTRY(ACTION_NEXT)),
-		.call = parse_vc,
-	},
 	[ACTION_OF_SET_NW_TTL] = {
 		.name = "of_set_nw_ttl",
 		.help = "OpenFlow's OFPAT_SET_NW_TTL",
diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index 81a0701a70..a5ff8fd64e 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -2123,23 +2123,6 @@ fields in the pattern items.
    | 1     | END      |
    +-------+----------+
 
-Action: ``OF_DEC_MPLS_TTL``
-^^^^^^^^^^^^^^^^^^^^^^^^^^^
-This action is deprecated. Consider `Action: MODIFY_FIELD`_.
-
-Implements ``OFPAT_DEC_MPLS_TTL`` ("decrement MPLS TTL") as defined by the
-`OpenFlow Switch Specification`_.
-
-.. _table_rte_flow_action_of_dec_mpls_ttl:
-
-.. table:: OF_DEC_MPLS_TTL
-
-   +---------------+
-   | Field         |
-   +===============+
-   | no properties |
-   +---------------+
-
 Action: ``OF_SET_NW_TTL``
 ^^^^^^^^^^^^^^^^^^^^^^^^^
 This action is deprecated. Consider `Action: MODIFY_FIELD`_.
diff --git a/doc/guides/rel_notes/deprecation.rst b/doc/guides/rel_notes/deprecation.rst
index 9da1ac7ea4..40a1f427af 100644
--- a/doc/guides/rel_notes/deprecation.rst
+++ b/doc/guides/rel_notes/deprecation.rst
@@ -105,7 +105,7 @@ Deprecation Notices
   is deprecated as ambiguous with respect to the embedded switch. The use of
   these attributes will become invalid starting from DPDK 22.11.
 
-* ethdev: Actions ``OF_DEC_MPLS_TTL``, ``OF_SET_NW_TTL``,
+* ethdev: Actions ``OF_SET_NW_TTL``,
   ``OF_COPY_TTL_OUT``, ``OF_COPY_TTL_IN`` are deprecated as not supported by
   any PMD, so they will be removed in DPDK 22.11.
 
diff --git a/doc/guides/rel_notes/release_22_11.rst b/doc/guides/rel_notes/release_22_11.rst
index 794f6322dc..c3ace47ed8 100644
--- a/doc/guides/rel_notes/release_22_11.rst
+++ b/doc/guides/rel_notes/release_22_11.rst
@@ -109,8 +109,8 @@ Removed Items
 * ethdev: removed ``RTE_FLOW_ACTION_TYPE_PHY_PORT``;
   use ``RTE_FLOW_ACTION_TYPE_REPRESENTED_PORT``.
 
-* ethdev: removed ``OF_SET_MPLS_TTL`` which is not actually supported by
-  any PMD.
+* ethdev: removed ``OF_SET_MPLS_TTL`` and ``OF_DEC_MPLS_TTL`` which are not
+  actually supported by any PMD.
   ``MODIFY_FIELD`` action should be used to do packet edits via RTE flow API.
 
 
diff --git a/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c b/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
index 0528606e63..67f20d83c1 100644
--- a/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
+++ b/drivers/net/bnxt/tf_ulp/ulp_rte_handler_tbl.c
@@ -73,10 +73,6 @@ struct bnxt_ulp_rte_act_info ulp_act_info[] = {
 	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
 	.proto_act_func          = NULL
 	},
-	[RTE_FLOW_ACTION_TYPE_OF_DEC_MPLS_TTL] = {
-	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
-	.proto_act_func          = NULL
-	},
 	[RTE_FLOW_ACTION_TYPE_OF_SET_NW_TTL] = {
 	.act_type                = BNXT_ULP_ACT_TYPE_NOT_SUPPORTED,
 	.proto_act_func          = NULL
diff --git a/lib/ethdev/rte_flow.c b/lib/ethdev/rte_flow.c
index ca7634bbe9..25f13e0287 100644
--- a/lib/ethdev/rte_flow.c
+++ b/lib/ethdev/rte_flow.c
@@ -192,7 +192,6 @@ static const struct rte_flow_desc_data rte_flow_desc_action[] = {
 	MK_FLOW_ACTION(PORT_ID, sizeof(struct rte_flow_action_port_id)),
 	MK_FLOW_ACTION(METER, sizeof(struct rte_flow_action_meter)),
 	MK_FLOW_ACTION(SECURITY, sizeof(struct rte_flow_action_security)),
-	MK_FLOW_ACTION(OF_DEC_MPLS_TTL, 0),
 	MK_FLOW_ACTION(OF_SET_NW_TTL,
 		       sizeof(struct rte_flow_action_of_set_nw_ttl)),
 	MK_FLOW_ACTION(OF_DEC_NW_TTL, 0),
diff --git a/lib/ethdev/rte_flow.h b/lib/ethdev/rte_flow.h
index f49d138fe9..c60f85690e 100644
--- a/lib/ethdev/rte_flow.h
+++ b/lib/ethdev/rte_flow.h
@@ -2275,17 +2275,6 @@ enum rte_flow_action_type {
 	 */
 	RTE_FLOW_ACTION_TYPE_SECURITY,
 
-	/**
-	 * @deprecated
-	 * @see RTE_FLOW_ACTION_TYPE_MODIFY_FIELD
-	 *
-	 * Implements OFPAT_DEC_MPLS_TTL ("decrement MPLS TTL") as defined
-	 * by the OpenFlow Switch Specification.
-	 *
-	 * No associated configuration structure.
-	 */
-	RTE_FLOW_ACTION_TYPE_OF_DEC_MPLS_TTL,
-
 	/**
 	 * @deprecated
 	 * @see RTE_FLOW_ACTION_TYPE_MODIFY_FIELD